(function( $ ) {
	'use strict';

	/**
	 * All of the code for your admin-facing JavaScript source
	 * should reside in this file.
	 *
	 * Note: It has been assumed you will write jQuery code here, so the
	 * $ function reference has been prepared for usage within the scope
	 * of this function.
	 *
	 * This enables you to define handlers, for when the DOM is ready:
	 *
	 * $(function() {
	 *
	 * });
	 *
	 * When the window is loaded:
	 *
	 * $( window ).load(function() {
	 *
	 * });
	 *
	 * ...and/or other possibilities.
	 *
	 * Ideally, it is not considered best practise to attach more than a
	 * single DOM-ready or window-load handler for a particular page.
	 * Although scripts in the WordPress core, Plugins and Themes may be
	 * practising this, we should strive to set a better example in our own work.
	 */
	$( window ).load(function() {
	/** collapsible section */
	var coll = document.getElementsByClassName("collapsible");
	var i;

	for (i = 0; i < coll.length; i++) {
	coll[i].addEventListener("click", function() {
		this.classList.toggle("active");
		var content = this.nextElementSibling;
		if (content.style.display === "block") {
		content.style.display = "none";
		} else {
		content.style.display = "block";
		}
	});
	}

	/**Download log files */
	var page_url = 	$("#kount_page_url").val();
	var filename =	$("#logs_files").val();
	$("#download_btn").attr("href",page_url+"&download_file="+filename);

	/** logs file dropdown onchange */
	$("#logs_files").change(function(){
		page_url = 	$("#kount_page_url").val();
		filename =	$(this).val();
		$("#download_btn").attr("href",page_url+"&download_file="+filename);
	})
	
	/** Validation for admin configuration */
	var validation_error= false;
	$("#setting-notice").css("display","none");

	/**Calling onchange event on input field */
	$('input[type="text"]').change(function(e){
		var value=$(this).val();
		$(this).val(value);
	});

	/**Off all functionality if plugin is disabled */
	$('#is_plugin_enable').change(function(){
		disable_plugin();
	});

	/**off login trusted device is login disabled */
	$('#is_login_enable').change(function(){
		var is_login_enable= $("#is_login_enable").is(":checked");
		if(is_login_enable == false){
			$('#is_trusted_device_login_allow').prop("checked", false);
		}
	});

	/**off account trusted device is account creation disabled */
	$('#is_account_creation_enable').change(function(){
		var is_account_enable= $("#is_account_creation_enable").is(":checked");
		if(is_account_enable == false){
			$('#is_trusted_device_enable').prop("checked", false);
		}
	});

	/**Submit button click */
	$("#submit_btn").click(function(){
		disable_plugin();

		/**Getting the toggles value */
		var is_login_enable= $("#is_login_enable").is(":checked");
		var payment_website = $('#payment_website').val();
		var account_website = $('#account_website').val();
		var kount_merchant_id = $("#kount_merchant_id").val();
		var api_key = $("#api_key").val();
		var is_account_enable= $("#is_account_creation_enable").is(":checked");
		var is_payment_enable_= $("#is_payment_enable").is(":checked");

		if(is_login_enable == false){
			$('#is_trusted_device_login_allow').prop("checked", false);
		}
		if(is_account_enable == false){
			$('#is_trusted_device_enable').prop("checked", false);
		}

		if(kount_merchant_id == ""){
			show_message("Merchant ID required.","block");
			validation_error= true;
		}
		else if(kount_merchant_id.length < 6){
			show_message("Invalid Merchant ID.","block");
			validation_error= true;
		}
		else if(payment_website ==""){
			show_message("Website ID for payment is required.","block");
			validation_error= true;
		}
		else if(account_website ==""){
			show_message("Account creation website ID is required.","block");
			validation_error= true;
		}
		else if(api_key ==""){
			show_message("Payment API key required.","block");
			validation_error= true;
		}
		else{
			validation_error= false;
		}

		if(is_payment_enable_ == true && validation_error== false){
			var order_cancellation_message = $("#order_cancellation_message").val();
			if(order_cancellation_message ==""){
				show_message("Order Cancellation Message required.","block");
				validation_error= true;
			}
			else{
				show_message("","none");
				validation_error= false;
			}
		}

		if(is_login_enable == true && validation_error== false ){
			var login_api_key = $("#login_api_key").val();
			if(login_api_key ==""){
				show_message("Login API key required.","block");
				validation_error= true;
			}
			else{
				show_message("","none");
				validation_error= false;
			}
		}

		var days_number = Number($("#delete_logs_in").val());
		if(days_number != "" && validation_error == false){
			if (/^[0-9]{1,3}$/.test(days_number)) { 
				show_message("","none");
				validation_error= false;
			}
			else{
				show_message("Max 3 digits are allowed in logs deletion days.","block");
				validation_error= true;
			}
		}

		/**If validation error is false than save the form data */
		if(validation_error == false){
			$( "#submit" ).trigger( "click" );
		}
	});

	/**Regenerate keys */
	$("#regenerate_btn").click(function(){
		$("#regenerate_keys").val("true");
		show_message("Consumer key and consumer secret key are re-generated. Please click save changes for save keys.","block","regenerate");
	});

	/**Trusted device documentation */
	var trusted_doc='<span class="close_kount_modal">&times;</span><h3>Steps for create Trusted Device</h3><p>1) If the Kount login status is "Challenge" and login functionality is on, and trusted device is on only when trusted device will add for user.</p><p>2) The user needs to submit the trusted device details to add a trusted device for the customer.</p><p>3) It is up to the merchant to code the connection between step-up and the Trusted Device API call.</p><p>4) User should call "KFPWOO_Trusted_Device::kfpwoo_submit_trusted_device()" function.</p><p>5) In this function, the user needs to pass trusted device details as a parameter.</p><p>6) It will accept data in an array format. Create an array with the below details:</p><p><ul style="list-style:disc;padding-left:30px"><li>User ID (send with key "user_id")<br>Client’s unique identifier for a Client’s User</li><li>Session ID (send with key "session_id")<br>For getting session Id we need to call "KFPWOO_Login_Risk_Inquiry::kfpwoo_get_login_status()" function. (pass user id as parameter in this function). This function will return a array contains kount login status and session id.</li><li>Trust Status (send with key "trust_status")<br>(Enum: "TRUSTED" "BANNED" "UNASSIGNED")<br>TRUSTED - Used to minimize friction for a User who has passed step-up authentication.<br>BANNED - Used to block access to an account for a specified Device<br>UNASSIGNED - Used to preserve a connection between a user and a device without a trust judgment.</li><li>Friendly Name (send with key "friendly_name")<br>The Human readable identifier for a Device. If not provided, a default name will be generated based on Device attributes.</li><li>Trusted device create for (send with key "via" and value "login")</li></ul></p><p>7) After all setup, you will get "Success" response from API.</p>';
	/**Step-up documentation */
	var stepup_doc='<span class="close_kount_modal">&times;</span><h3>Steps to Implement Kount with Step-up Challenge</h3><p>1) If the Kount login status is "Challenge" and login functionality is on, only when user will proceed with setp-up.</p><p>2) "KFPWOO_Merchant_Settings::$is_login_enable" will return true if login functionality is on. So put condition before below implementation.</p><p>3) For getting Kount login status we need to call "KFPWOO_Login_Risk_Inquiry::kfpwoo_get_login_status()" function.</p><p>4) In this function, the user needs to pass user ID as a parameter.</p><p>5) This function will return a array that contains kount login status and session id.</p><p>6) The user needs to implement Step-up Challenge. The user can add the plugin and create their own custom plugin for Step-up Challenge.</p><p>7) The user needs to call a function if step-up challenge returns "Success" or "Failed."</p><p>8) User should call "KFPWOO_Stepup_Challenge::kfpwoo_login_challenge_outcome()" function.</p><p>9) In this function, the user needs to pass step-up challenge details as a parameter.</p><p>10) It will accept data in an array format. Create an array with the below details:</p><p><ul style="list-style:disc;padding-left:30px"><li>User ID (send with key "user_id") Client’s unique identifier for a Client’s User</li><li>Session ID (send with key "session_id") (Session ID we got from step(4) )</li><li>Challenge Type (Type of step-up challenge you are using, need to send with key "challenge_type")</li><li>Challenge Status (What is the status ("Success/Failed") of Step-up Challenge, need to send with key "challenge_status")</li><li>Challenge Sent Timestamp (GMT timestamp when the challenge was sent to Client\'s User, send with key "challenge_sent_timestamp" and format "YYYY-MM-DD\'T\'hh:mm:ss.fff\'Z\'")</li><li>Challenge Completed Timestamp (GMT timestamp when the Client\'s User completed the challenge, send with key "challenge_completed_timestamp" and format "YYYY-MM-DD\'T\'hh:mm:ss.fff\'Z\'")</li><li>Challenge Failure Type (If the challenge is failed, the reason for the failure otherwise send blank, send with key "challenge_failure_type")</li></ul></p><p>11) After all setup, you will receive a "Success" response from API.</p>';

	/**Get the model */
	var kount_modal = document.getElementById("kountModal");
	// When the user clicks on the button, open the modal
	$(".kount_doc_btn").click(function() {
		var data_type=$(this).attr("data-type");
		if(data_type =="stepup_challenge"){
			$("#kountModal").find(".modal-content").html(stepup_doc);
		}else if(data_type =="trusted_device"){
			$("#kountModal").find(".modal-content").html(trusted_doc);
		}
		kount_modal.style.display = "block";
	});

	// When the user clicks on <span> (x), close the modal
	$(document).on('click',".close_kount_modal",function() {
		kount_modal.style.display = "none";
	});

	// When the user clicks anywhere outside of the modal, close it
	window.onclick = function(event) {
		if (event.target == kount_modal) {
			kount_modal.style.display = "none";
		}
	}

	/**Notice close button action */
	$(document).on('click', '#setting-notice .notice-dismiss', function(){ 
		$("#setting-notice").remove();
	});
});

/**Disable plugin*/
function disable_plugin(){
	var is_plugin_enable1 = $('#is_plugin_enable').is(":checked");
	if(is_plugin_enable1 == false){
		 $('#is_payment_enable').prop("checked", false);
		 $('#is_account_creation_enable').prop("checked", false);
		 $('#is_login_enable').prop("checked", false);
		 $('#is_trusted_device_enable').prop("checked", false);
		 $('#is_trusted_device_login_allow').prop("checked", false);
	}
}

/**show error message*/
function show_message(msg, display_error, regenerate){
	if(regenerate == "regenerate"){
		if($("#setting-notice").length == 0) {
				$("div#notice_block").append('<div id="setting-notice" class="notice is-dismissible notice-success" style="display: block;"><p>'+msg+'</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
		} else {
			$("#setting-notice").removeClass("notice-error");
			$("#setting-notice").addClass("notice-success");
		}
	} else if(display_error == "block") {
		if($("#setting-notice").length == 0) {
			$("div#notice_block").append('<div id="setting-notice" class="notice is-dismissible notice-error" style="display: block;"><p>'+msg+'</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>');
		} else {
			$("#setting-error-settings_updated").css("display",'none');
			$("#setting-notice").addClass("notice-error");
			$("#setting-notice").removeClass("notice-success");
		}
	} else {
		$("#setting-notice").removeClass("notice-error");
	}
	$("#setting-notice").find("p").text(msg);
	$("#setting-notice").css("display",display_error);
	/***IF error occur then focus on the error */
	$("html, body").animate({ scrollTop: 0 }, "slow");
}

})( jQuery );