<?php
/**
 * Copyright (c) 2021 Kount, Inc.

 * This file is part of Kount Fraud Prevention.

 * Kount Fraud Prevention is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Kount Fraud Prevention is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Kount Fraud Prevention.  If not, see <https://www.gnu.org/licenses/>.
 */
/**
 * Config_
 *
 * API endpoints configuration
 *
 * @since      1.0.0
 * @package    Kount
 * @subpackage Kount/Config
 * @author     Kount Inc. <developer@kount.com>
 *
 */
Class KFPWOO_Config_ {

    /**
     * config_
     *
     * @return void
     */
    public function config_(){
        $config_data=[
            'BASE_URL'              =>  site_url(),
            'RIS_ENDPOINT'          =>  '/woo/orderAssessment',
            'LOGIN_ENDPOINT'        =>  '/login',
            'EVENTS_ENDPOINT'       =>  '/events',
            'TRUSTED_DEVICE'        =>  '/trusted-device',
            'X-CORRELATION-ID'      =>  KFPWOO_Merchant_Settings::$correlation_ID,
            'INSTALL_ENDPOINT'      =>  '/woo/install',
            'WOO_API_ENDPOINTS'     =>  'kount',
            'LOGIN_URL'             =>  KFPWOO_LOGIN_URL,
            'RIS_URL'               =>  KFPWOO_RIS_URL,
            'DDC_URL'               =>  KFPWOO_DDC_URL,
            'CUSTOMER_ASSESSMENT'   =>  '/woo/customerAssessment',
        ];
        return $config_data;
    }

}

?>
